package com.lightinit.hsdatashow.impl.ms;

import com.lightinit.hsdatashow.entity.AgeStructure;
import com.lightinit.hsdatashow.entity.AgeStructureExample;
import com.lightinit.hsdatashow.entity.BaseExample;
import com.lightinit.hsdatashow.mapper.AgeStructureMapper;
import com.lightinit.hsdatashow.mapper.AverageExpectedRateMapper;
import com.lightinit.hsdatashow.model.ResultState;
import com.lightinit.hsdatashow.model.ResultStateCode;
import com.lightinit.hsdatashow.service.ms.IMSAgeStructureService;
import com.lightinit.hsdatashow.spring.DynamicDataContextHolder;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

@Service
public class MSAgeStructureServiceImpl implements IMSAgeStructureService {
    @Autowired
    private AgeStructureMapper ageStructureMapper;
    @Override
    public List<AgeStructure> queryList(BaseExample.Page pager) {
        DynamicDataContextHolder.setCustomerType(DynamicDataContextHolder.DEFAULT);
        AgeStructureExample example = new AgeStructureExample();
        example.setPage(pager);
        return ageStructureMapper.selectByExample(example);
    }

    @Override
    public long queryCount(BaseExample.Page pager) {
        DynamicDataContextHolder.setCustomerType(DynamicDataContextHolder.DEFAULT);
        AgeStructureExample example = new AgeStructureExample();
        example.setPage(pager);
        return ageStructureMapper.countByExample(example);
    }

    @Override
    public ResultState<Long> delete(long id) {
        ResultState<Long> resultState = new ResultState<Long>();
        DynamicDataContextHolder.setCustomerType(DynamicDataContextHolder.DEFAULT);
        if (!(ageStructureMapper.deleteByPrimaryKey(id)>0)){
            resultState.setStateCode(ResultStateCode.INVALID_DATA);
            resultState.setMsg("数据不存在");
        }
        resultState.setData(id);
        return resultState;
    }

    @Override
    public ResultState add(AgeStructure inputModel) {
        ResultState<Long> resultState = new ResultState<Long>();
        DynamicDataContextHolder.setCustomerType(DynamicDataContextHolder.DEFAULT);
        inputModel.setCreatedAt(new Date());
        AgeStructure entity = new AgeStructure();
        BeanUtils.copyProperties(inputModel, entity);
        long sqlResult = ageStructureMapper.insert(entity);
        if (!(sqlResult > 0)){
            resultState.setStateCode(ResultStateCode.INVALID_DATA);
            resultState.setMsg("数据插入失败");
        }
        resultState.setData(entity.getId());
        return resultState;
    }

    @Override
    public AgeStructure edit(long id) {
        DynamicDataContextHolder.setCustomerType(DynamicDataContextHolder.DEFAULT);
        return ageStructureMapper.selectByPrimaryKey(id);
    }

    @Override
    public ResultState doEdit(AgeStructure inputModel) {
        DynamicDataContextHolder.setCustomerType(DynamicDataContextHolder.DEFAULT);
        ResultState<Long> resultState = new ResultState<Long>();
        if (!(ageStructureMapper.updateByPrimaryKey(inputModel)>0)){
            resultState.setStateCode(ResultStateCode.INVALID_DATA);
            resultState.setMsg("数据不存在");
        }
        resultState.setData(inputModel.getId());
        return resultState;
    }
}
